﻿// client.cpp : 이 파일에는 'main' 함수가 포함됩니다. 거기서 프로그램 실행이 시작되고 종료됩니다.
//

#include <stdio.h>
#include <stdlib.h>
#include <string>
#include <ws2tcpip.h>
#include <WinSock2.h>
#include <memory>
#include <iostream>
#include "../common.h"
#include "../event_generated.h"

#pragma comment(lib, "ws2_32.lib")

struct PACKET_HEADER
{
	int type;
	int size;
};

enum { ID_SC_HELLO = 1 };

struct SC_HELLO : public PACKET_HEADER
{
	SC_HELLO() { type = ID_SC_HELLO; size = sizeof(*this); }
	char message[32] = "Hello World";
};

#pragma comment(lib, "ws2_32.lib")

char gServerIP[1024] = "192.168.219.105";
const int gPort = 1977;
void DeserializeUnion(uint8_t* data, int deBufSize);

void ErrorHandling(const char *message);

#include <ws2tcpip.h>
#define MAX_IP_STRING_LENGTH 1024
bool GetLocalIP(std::string& strIP)
{
	char host_name[256];
	if (gethostname(host_name, 256) == SOCKET_ERROR)
		return false;

	struct addrinfo hints, *res = NULL;
	char *szRemoteAddress = NULL, *szRemotePort = NULL;
	int rc; 
	memset(&hints, 0, sizeof(hints));
	hints.ai_family = AF_INET;
	hints.ai_socktype = SOCK_STREAM;
	hints.ai_protocol = IPPROTO_TCP;

	rc = getaddrinfo(host_name, szRemotePort, &hints, &res);
	if (rc == WSANO_DATA) { return false; }

	char szIP[MAX_IP_STRING_LENGTH] = { 0, };
	sprintf_s(szIP, MAX_IP_STRING_LENGTH, "%d.%d.%d.%d",
		(unsigned char)res->ai_addr->sa_data[2],
		(unsigned char)res->ai_addr->sa_data[3],
		(unsigned char)res->ai_addr->sa_data[4],
		(unsigned char)res->ai_addr->sa_data[5]);

	strIP = szIP;
	return true;
}

int DoRecv(SOCKET sock)
{
	int buffLen = 0;
	int len = recv(sock, (char*)&buffLen, 4, 0);
	if (len == -1)
	{
		ErrorHandling("recv buffer length Error\n");
		return -1;
	}

	std::unique_ptr<uint8_t[]> buff(new uint8_t[buffLen]);
	len = recv(sock, (char*)buff.get(), buffLen, 0);
	if (len == -1)
	{
		ErrorHandling("recv buffer Error\n");
		return -1;
	}
	DeserializeUnion(buff.get(), buffLen);

	return 0;
}

int main(int argc, char** argv)
{
	WSADATA wsadata;
	SOCKET sock;
	SOCKADDR_IN ServAddr;
	int len;

	if (WSAStartup(MAKEWORD(2, 2), &wsadata) != 0)
		ErrorHandling("WSAStartup Error\n");

	sock = socket(PF_INET, SOCK_STREAM, 0);
	if (sock == INVALID_SOCKET)
		ErrorHandling("Socket Error\n");

	memset(&ServAddr, 0, sizeof(ServAddr));
	ServAddr.sin_family = AF_INET;
	//ServAddr.sin_addr.s_addr = inet_addr(gServerIP);

	std::string localIP;
	GetLocalIP(localIP);  //서버와 클라이언트를 한PC에서 테스트 한다.
	strcpy_s(gServerIP, 1024, localIP.c_str());
	inet_pton(AF_INET, gServerIP, &ServAddr.sin_addr);
	ServAddr.sin_port = htons(gPort);

	//생성된 소켓을 이용하여 서버에 연결 요청
	if (connect(sock, (SOCKADDR*)&ServAddr, sizeof(ServAddr)) == SOCKET_ERROR)
		ErrorHandling("connect Error\n");

	//recv 함수를 통해서 서버로 부터 전송되는 데이터 수신
#ifdef	PACKET_SAMPLE1
	char message[100];
	len = recv(sock, message, sizeof(message) - 1, 0);
	if (len == -1)
		ErrorHandling("recv Error\n");

	printf("MESSAGE FROM SERVER : %s", message);
#endif

#ifdef	PACKET_SAMPLE2
	SC_HELLO packet;
	memset((void*)&packet.message, 0, 32);
	len = recv(sock, (char*)&packet, packet.size, 0);
	if (len == -1)
		ErrorHandling("recv Error\n");

	if (packet.type == ID_SC_HELLO)
		printf("MESSAGE FROM SERVER : %s", packet.message);
#endif

#ifdef PACKET_SAMPLE3
	DoRecv(sock);
	DoRecv(sock);
#endif

	printf("\nSOCKET OVER\n");
	closesocket(sock);
	WSACleanup();
	
	getchar();
	return 0;
}

void ErrorHandling(const char *message)
{
	printf("%s", message);
	//fputs(message, stderr);
	//fputs("\n", stderr);
	exit(1);
}

void DeserializeUnion(uint8_t* data, int deBufSize)
{
	flatbuffers::Verifier verifier(data, deBufSize);
	bool res = MyEvent::VerifyEventHolderBuffer(verifier);
	if (res)
	{
		auto eventHolder = MyEvent::GetEventHolder(data);
		if (eventHolder->event_type() == MyEvent::EventCmd_EventStart)
		{
			const MyEvent::EventStart* e = eventHolder->event_as<MyEvent::EventStart>();
			std::cout << "MyEvent::EventStart  " << "아이디 : " << e->id() << std::endl;
			std::cout << "MyEvent::EventStart  " << "타임 : " << e->time() << std::endl;
		}
		else if (eventHolder->event_type() == MyEvent::EventCmd_EventEnd)
		{
			const MyEvent::EventEnd* e = eventHolder->event_as<MyEvent::EventEnd>();
			if (e == nullptr)
			{
				printf("\n EventEnd is nullptr\n");
			}
			else
			{
				int id = e->id();
				std::cout << "MyEvent::EventEnd 아이디 : " << e->id() << std::endl;
				std::cout << "MyEvent::EventEnd 메세지 : " << e->message()->c_str() << std::endl;
			}
		}
	}
}
