﻿// server.cpp : 이 파일에는 'main' 함수가 포함됩니다. 거기서 프로그램 실행이 시작되고 종료됩니다.
//

#include <stdio.h>
#include <stdlib.h>
#include <WinSock2.h>
#include "../common.h"
#include "../event_generated.h"

#pragma comment(lib, "ws2_32.lib")

struct PACKET_HEADER
{
	int type;
	int size;
};

enum { ID_SC_HELLO = 1 };

struct SC_HELLO : public PACKET_HEADER
{
	SC_HELLO() { type = ID_SC_HELLO; size = sizeof(*this); }
	char message[32] = "Hello World Sample2";
};


const int gPort = 1977;

void Send_UnionSample_Satart(SOCKET socket, int id, float startTime);
void Send_UnionSample_End(SOCKET socket, int id, std::string msg);
void ErrorHandling(const char *message);
int main(int argc, char** argv)
{
	WSADATA wsadata;
	SOCKET ServSock, CliSock;
	SOCKADDR_IN servAddr, cliAddr;
	int szCliAddr;

	if (WSAStartup(MAKEWORD(2, 2), &wsadata) != 0)
		ErrorHandling("WSAStartup Error\n");

	ServSock = socket(PF_INET, SOCK_STREAM, 0);

	if (ServSock == INVALID_SOCKET)
		ErrorHandling("socket 생성 실패\n");

	memset(&servAddr, 0, sizeof(servAddr));
	servAddr.sin_family = AF_INET;
	servAddr.sin_port = htons(gPort);

	servAddr.sin_addr.s_addr = htonl(INADDR_ANY);

	if (bind(ServSock, (SOCKADDR*)&servAddr, sizeof(servAddr)) == SOCKET_ERROR)
		ErrorHandling("bind() ERROR\n");

	if (listen(ServSock, 5) == SOCKET_ERROR)
		ErrorHandling("listen() ERROR\n");

	szCliAddr = sizeof(cliAddr);
	CliSock = accept(ServSock, (SOCKADDR*)&cliAddr, &szCliAddr);
	if (CliSock == INVALID_SOCKET)
		ErrorHandling("accept() ERROR\n");
	else
		printf("CONNECTION SUCCESS . . . . . . .\n");

	//send()함수를 통해서 클라이언트에 메세지 전송
#ifdef	PACKET_SAMPLE1
	char message[] = "hello ! Welcome Sample1!";
	send(CliSock, message, sizeof(message), 0);
#endif

#ifdef PACKET_SAMPLE2
	SC_HELLO packet;
	send(CliSock, (char*)&packet, packet.size, 0);
#endif

#ifdef PACKET_SAMPLE3
	Send_UnionSample_Satart(CliSock, 100, 0.8f);
	Send_UnionSample_End(CliSock, 5, "quit5");
#endif

	closesocket(CliSock);
	closesocket(ServSock);
	WSACleanup();

	getchar();
	return 0;
}


void ErrorHandling(const char *message)
{
	printf("%s", message);
	//fputs(message, stderr);
	//fputs("\n", stderr);
	exit(1);
}

void Send_UnionSample_Satart(SOCKET socket, int id, float startTime)
{
	flatbuffers::FlatBufferBuilder builder;

	//직렬화 serialize
	auto startOffset = MyEvent::CreateEventStart(builder, id, startTime);
	auto rootOffset = MyEvent::CreateEventHolder(builder, MyEvent::EventCmd_EventStart, startOffset.Union());

	builder.FinishSizePrefixed(rootOffset);

	auto data = builder.GetBufferPointer();
	auto bufSize = builder.GetSize();

	flatbuffers::Verifier verifier(data, bufSize);
	bool ok = MyEvent::VerifySizePrefixedEventHolderBuffer(verifier);
	if (ok)
	{
		send(socket, (const char*)data, bufSize, 0);
	}
}

void Send_UnionSample_End(SOCKET socket, int id, std::string msg)
{
	flatbuffers::FlatBufferBuilder builder;

	//직렬화 serialize
	auto offset = MyEvent::CreateEventEnd(builder, id, builder.CreateString(msg.c_str()));
	auto rootOffset = MyEvent::CreateEventHolder(builder, MyEvent::EventCmd_EventEnd, offset.Union());

	builder.FinishSizePrefixed(rootOffset);

	auto data = builder.GetBufferPointer();
	auto bufSize = builder.GetSize();

	flatbuffers::Verifier verifier(data, bufSize);
	bool ok = MyEvent::VerifySizePrefixedEventHolderBuffer(verifier);
	if (ok)
	{
		send(socket, (const char*)data, bufSize, 0);
	}
}
